export declare const P: (m: number, n: number) => number;
export declare const C: (m: number, n: number) => number;
interface IndexesInteface {
    pickFrom<E>(ary: ReadonlyArray<E>): ReadonlyArray<E>;
    omitFrom<E>(ary: ReadonlyArray<E>): ReadonlyArray<E>;
}
declare abstract class AbstractIndexes<T> implements IndexesInteface {
    protected m: number;
    protected indexes: T;
    constructor(m: number, indexes: T);
    pickFrom<E>(ary: ReadonlyArray<E>): ReadonlyArray<E>;
    omitFrom<E>(ary: ReadonlyArray<E>): ReadonlyArray<E>;
    protected abstract negateIndexes(): T;
    protected abstract forIndex(indexes: T, callback: (enable: boolean, index: number) => void): void;
}
declare abstract class AbstractCombination<T> implements IterableIterator<T> {
    readonly m: number;
    readonly r: number;
    readonly count: number;
    constructor(m: number, r: number);
    isValid(): boolean;
    abstract next(): IteratorResult<T>;
    [Symbol.iterator](): IterableIterator<T>;
}
declare class Indexes30 extends AbstractIndexes<number> {
    constructor(m: number, indexes: number);
    protected negateIndexes(): number;
    forIndex(indexes: number, callback: (enable: boolean, index: number) => void): void;
}
export declare class Combination30 extends AbstractCombination<Indexes30> {
    private readonly maxIndex;
    private indexes;
    constructor(m: number, r: number);
    next(): IteratorResult<Indexes30>;
    isValid(): boolean;
    private static nextIndex_30bit;
}
declare class IndexesBig extends AbstractIndexes<number[]> {
    constructor(m: number, indexes: number[]);
    protected negateIndexes(): number[];
    forIndex(indexes: number[], callback: (enable: boolean, index: number) => void): void;
}
export declare class CombinationBig extends AbstractCombination<IndexesBig> {
    private indexes;
    constructor(m: number, r: number);
    next(): IteratorResult<IndexesBig>;
    static nextIndex_30bit: (indexes: number[], nelem: number) => number[];
}
export declare const Combination: (m: number, r: number) => AbstractCombination<IndexesInteface>;
export {};
